<template>
    <div>
        <!-- profile completion modal -->
        <div class="modal fade" id="modal-form" tabindex="0" role="dialog" aria-labelledby="modal-form"
             aria-hidden="true">
            <div class="modal-dialog modal- modal-dialog-centered modal-sm" role="document">
                <div class="modal-content">
                    <div class="modal-body p-0">
                        <div class="card bg-secondary shadow border-0">
                            <div class="card-header bg-white">
                                <div class="text-muted text-center mb-3">Complete your Profile</div>
                            </div>
                            <div class="card-body px-lg-5 py-lg-5">
                                <form role="form">
                                    <!-- input: name -->
                                    <div class="form-group"
                                         :class="{'has-danger': !completeProfileForm.name.valid || $v.completeProfileForm.name.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'user']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.name.valid || $v.completeProfileForm.name.$error}"
                                                   v-model.trim="$v.completeProfileForm.name.val.$model" name="name"
                                                   placeholder="Name" type="text">
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.name.val.required && $v.completeProfileForm.name.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.name.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.name.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- input: profession -->
                                    <div class="form-group mb-3"
                                         :class="{'has-danger': selectedCategory && submitted}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'user-tie']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <base-dropdown class="col-sm-10">
                                                <base-button slot="title" type="secondary" class="dropdown-toggle col-sm-12">
                                                    <span v-if="selectedCategory">{{ selectedCategory.name }}</span>
                                                    <span v-else>profession</span>
                                                </base-button>
                                                <a v-for="category in categories" @click="selectCategory(category)" class="dropdown-item" href="#">{{ category.name }}</a>
                                            </base-dropdown>
                                        </div>

                                        <!-- validation msgs -->
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!selectedCategory && submitted"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.profession.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.profession.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- input: description -->
                                    <div class="form-group mb-3"
                                         :class="{'has-danger': !completeProfileForm.description.valid || $v.completeProfileForm.description.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'align-left']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.description.valid || $v.completeProfileForm.description.$error}"
                                                   v-model.trim="$v.completeProfileForm.description.val.$model"
                                                   placeholder="description" type="text">
                                        </div>

                                        <!-- validation msgs -->
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.description.val.required && $v.completeProfileForm.description.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.description.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.description.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- input: city -->
                                    <div class="form-group mb-3"
                                         :class="{'has-danger': !completeProfileForm.city.valid || $v.completeProfileForm.city.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'city']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.city.valid || $v.completeProfileForm.city.$error}"
                                                   v-model.trim="$v.completeProfileForm.city.val.$model"
                                                   placeholder="city" type="text">
                                        </div>
                                        <!-- validation msgs -->
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.city.val.required && $v.completeProfileForm.city.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.city.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.city.msg }}</span>
                                        </div>
                                    </div>

                                    <!-- submit -->
                                    <div class="text-center">
                                        <button v-if="!completeProfileForm.loading" @click.prevent="complete"
                                                type="button" class="btn btn-primary my-4">Complete
                                        </button>
                                        <spring-spinner
                                                v-else
                                                :animation-duration="1500"
                                                :size="64"
                                                color="#5e72e4"
                                                style="width: 100%"
                                        />
                                    </div>
                                </form>
                            </div>
                        </div>


                    </div>

                </div>
            </div>
        </div>
        <div v-if="profileCompletion">
            <div class="col-xl-8 order-xl-1">
                <card shadow type="secondary">
                    <div slot="header" class="bg-white border-0">
                        <div class="row align-items-center">
                            <div class="col-8">
                                <h3 class="mb-0">My account</h3>
                            </div>
                        </div>
                    </div>
                    <template>
                        Complete your Profile first
                    </template>
                </card>
            </div>
        </div>
        <div v-else class="container-fluid mt--7">
            <div class="row">
                <div class="col-xl-6 order-xl-2 mb-5 mb-xl-0">
                    <div class="card card-profile shadow mt--400">
                        <div class="container">
                            <div class="card card-profile shadow mt--400">
                                <div class="px-4">
                                    <div class="row justify-content-center">
                                        <div class="col-lg-3 order-lg-2">
                                            <div class="card-profile-image">
                                                <a href="#">
                                                    <img src="~assets/img/theme/team-4-800x800.jpg" class="rounded-circle"
                                                         alt="image">
                                                </a>
                                            </div>
                                        </div>
                                        <div class="col-lg-4 order-lg-3 text-lg-right align-self-lg-center">
                                            <div class="card-profile-actions py-4 mt-lg-0">
                                            </div>
                                        </div>
                                        <div class="col-lg-4 order-lg-1">

                                        </div>
                                    </div>
                                    <div class="text-center mt-8 mb-5">
                                        <h3>{{ $auth.user.name }}<span class="font-weight-light"></span></h3>
                                        <div class="h6 font-weight-300"><i class="ni location_pin mr-2"></i>{{ $auth.user.city
                                            }}
                                        </div>
                                    </div>
                                    <div class="mt-5 py-5 border-top text-center">
                                        <div class="row justify-content-center">
                                            <div class="col-lg-9">
                                                {{ $auth.user.description }}
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="col-xl-6 order-xl-1">
                    <card shadow type="secondary">
                        <div slot="header" class="bg-white border-0">
                            <div class="row align-items-center">
                                <div class="col-12">
                                    <h3 class="mb-0">My account</h3>
                                    <a @click.prevent="update" style="cursor: pointer" class="float-right btn btn-sm btn-info">save</a>
                                </div>
                            </div>
                        </div>
                        <template>
                            <form @submit.prevent>
                                <h6 class="heading-small text-muted mb-4">User information</h6>
                                <div class="pl-lg-4">
                                    <div class="row">
                                        <div class="col-lg-6">
                                            <div class="form-group"
                                                 :class="{'has-danger': !completeProfileForm.name.valid || $v.completeProfileForm.name.$error}">
                                                <div class="input-group input-group-alternative mb-3">
                                                    <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'user']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                                    </div>
                                                    <input class="form-control"
                                                           :class="{'is-invalid': !completeProfileForm.name.valid || $v.completeProfileForm.name.$error}"
                                                           v-model.trim="$v.completeProfileForm.name.val.$model" name="name"
                                                           placeholder="Name" type="text">
                                                </div>
                                                <div class="alert alert-danger alert-dismissible fade show"
                                                     v-if="!$v.completeProfileForm.name.val.required && $v.completeProfileForm.name.$error"
                                                     role="alert">
                                                    <span class="alert-inner--text">Field is required</span>
                                                </div>
                                                <div class="alert alert-danger alert-dismissible fade show"
                                                     v-if="!completeProfileForm.name.valid" role="alert">
                                                    <span class="alert-inner--text">{{ completeProfileForm.name.msg }}</span>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                    <div class="row">
                                        <div class="col-lg-6">
                                            <!-- input: profession -->
                                            <div class="form-group mb-3"
                                                 :class="{'has-danger': selectedCategory && submitted}">
                                                <div class="input-group input-group-alternative mb-3">
                                                    <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'user-tie']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                                    </div>
                                                    <base-dropdown class="col-sm-10">
                                                        <base-button slot="title" type="secondary" class="dropdown-toggle col-sm-12">
                                                            <span v-if="selectedCategory">{{ selectedCategory.name }}</span>
                                                            <span v-else>profession</span>
                                                        </base-button>
                                                        <a v-for="category in categories" @click="selectCategory(category)" class="dropdown-item" href="#">{{ category.name }}</a>
                                                    </base-dropdown>
                                                </div>

                                                <!-- validation msgs -->
                                                <div class="alert alert-danger alert-dismissible fade show"
                                                     v-if="!selectedCategory && submitted"
                                                     role="alert">
                                                    <span class="alert-inner--text">Field is required</span>
                                                </div>
                                                <div class="alert alert-danger alert-dismissible fade show"
                                                     v-if="!completeProfileForm.profession.valid" role="alert">
                                                    <span class="alert-inner--text">{{ completeProfileForm.profession.msg }}</span>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <hr class="my-4"/>
                                <!-- Address -->
                                <h6 class="heading-small text-muted mb-4">Contact information</h6>
                                <div class="pl-lg-4">
                                    <div class="row">
                                        <div class="col-lg-4">
                                            <!-- input: city -->
                                            <div class="form-group mb-3"
                                                 :class="{'has-danger': !completeProfileForm.city.valid || $v.completeProfileForm.city.$error}">
                                                <div class="input-group input-group-alternative mb-3">
                                                    <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'city']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                                    </div>
                                                    <input class="form-control"
                                                           :class="{'is-invalid': !completeProfileForm.city.valid || $v.completeProfileForm.city.$error}"
                                                           v-model.trim="$v.completeProfileForm.city.val.$model"
                                                           placeholder="city" type="text">
                                                </div>
                                                <!-- validation msgs -->
                                                <div class="alert alert-danger alert-dismissible fade show"
                                                     v-if="!$v.completeProfileForm.city.val.required && $v.completeProfileForm.city.$error"
                                                     role="alert">
                                                    <span class="alert-inner--text">Field is required</span>
                                                </div>
                                                <div class="alert alert-danger alert-dismissible fade show"
                                                     v-if="!completeProfileForm.city.valid" role="alert">
                                                    <span class="alert-inner--text">{{ completeProfileForm.city.msg }}</span>
                                                </div>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                                <hr class="my-4"/>
                                <!-- Description -->
                                <h6 class="heading-small text-muted mb-4">About me</h6>
                                <div class="pl-lg-4">
                                    <!-- input: description -->
                                    <div class="form-group mb-3"
                                         :class="{'has-danger': !completeProfileForm.description.valid || $v.completeProfileForm.description.$error}">
                                        <div class="input-group input-group-alternative mb-3">
                                            <div class="input-group-prepend">
                                                <span class="input-group-text"><font-awesome-icon
                                                        :icon="['fas', 'align-left']"
                                                        style="cursor: pointer; font-size: 22px;"/></span>
                                            </div>
                                            <input class="form-control"
                                                   :class="{'is-invalid': !completeProfileForm.description.valid || $v.completeProfileForm.description.$error}"
                                                   v-model.trim="$v.completeProfileForm.description.val.$model"
                                                   placeholder="description" type="text">
                                        </div>

                                        <!-- validation msgs -->
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!$v.completeProfileForm.description.val.required && $v.completeProfileForm.description.$error"
                                             role="alert">
                                            <span class="alert-inner--text">Field is required</span>
                                        </div>
                                        <div class="alert alert-danger alert-dismissible fade show"
                                             v-if="!completeProfileForm.description.valid" role="alert">
                                            <span class="alert-inner--text">{{ completeProfileForm.description.msg }}</span>
                                        </div>
                                    </div>
                                </div>
                            </form>
                        </template>
                    </card>
                </div>
            </div>
        </div>
    </div>
</template>
<script>
    import {required} from 'vuelidate/lib/validators'
    import {SpringSpinner} from 'epic-spinners'
    import Vue from 'vue'

    export default {
        name: 'user-profile',
        auth: 'auth',
        components: {
            SpringSpinner
        },
        data() {
            return {
                submitted: false,
                categories: [],
                selectedCategory: null,
                completeProfileForm: {
                    loading: false,
                    name: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    profession: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    description: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    city: {
                        val: '',
                        msg: '',
                        valid: true
                    },
                    success: false,
                    sent: false
                },
                model: {
                    username: '',
                    email: '',
                    firstName: '',
                    lastName: '',
                    address: '',
                    city: '',
                    country: '',
                    zipCode: '',
                    about: ''
                }
            }
        },
        validations: {
            completeProfileForm: {
                name: {
                    val: {
                        required
                    }
                },
                description: {
                    val: {
                        required
                    }
                },
                city: {
                    val: {
                        required
                    }
                },
            }
        },
        mounted() {
            this.getCategories();
            if (typeof this.$auth.user.name === 'undefined') {
                $("#modal-form").modal()
            }
            let self = this
            $('#modal-form').on('hidden.bs.modal', function (e) {
                if (typeof self.$auth.user.name === 'undefined') {
                    $("#modal-form").modal()
                }
            });
            this.setProfileData()
        },
        computed: {
            profileCompletion() {
                return typeof this.$auth.user.name === 'undefined'
            }
        },
        methods: {
            selectCategory (category) {
                this.selectedCategory = category;
            },
            getCategories () {
                this.$axios.get(process.env.BACKEND_API+'/matchcategories').then(results => {
                    this.categories = results.data
                })
            },
            setProfileData () {
              this.completeProfileForm.name.val = this.$auth.user.name
              this.completeProfileForm.profession.val = this.$auth.user.profession
              this.completeProfileForm.description.val = this.$auth.user.description
              this.completeProfileForm.city.val = this.$auth.user.city
                this.$axios.get(process.env.BACKEND_API+'/matchcategories').then(results => {
                    this.categories = results.data
                    this.selectedCategory = this.categories.find(x => x.name === this.$auth.user.profession);
                })
            },
            async update  () {
                // call local validation
                this.$v.completeProfileForm.$touch();
                this.submitted = true;
                if (this.$v.completeProfileForm.$pending || this.$v.completeProfileForm.$error || !this.selectedCategory) return;

                let completeProfileForm = this.completeProfileForm
                // send update request
                this.$axios.put(process.env.BACKEND_API + '/user/lawyer/profile', {
                    "name": completeProfileForm.name.val,
                    "profession": this.selectedCategory.name,
                    "description": completeProfileForm.description.val,
                    "city": completeProfileForm.city.val,
                }).then(results => {
                    completeProfileForm.name.valid = true
                    completeProfileForm.profession.valid = true
                    completeProfileForm.description.valid = true
                    completeProfileForm.city.valid = true
                    completeProfileForm.success = true;
                    completeProfileForm.sent = true;
                    completeProfileForm.loading = false
                    Vue.notify({
                        group: 'foo',
                        type: 'success',
                        title: 'Edit',
                        text: 'Successfully completed profile!'
                    })
                    $('#modal-form').modal('hide')
                    this.$auth.fetchUser()
                }).catch(error => {
                    console.log(error);
                    completeProfileForm.loading = false;
                    completeProfileForm.success = false;
                    completeProfileForm.sent = true;
                    Vue.notify({
                        group: 'foo',
                        type: 'error',
                        title: 'Error',
                        text: typeof error.response.data == 'string' ? error.response.data : 'Something went wrong!'
                    })
                    let errors = error.response.data.errors
                    if ("name" in errors) {
                        completeProfileForm.name.valid = false
                        completeProfileForm.name.msg = errors.name.message
                    }
                    if ("profession" in errors) {
                        completeProfileForm.profession.valid = false
                        completeProfileForm.profession.msg = errors.profession.message
                    }
                    if ("description" in errors) {
                        completeProfileForm.description.valid = false
                        completeProfileForm.description.msg = errors.description.message
                    }
                    if ("city" in errors) {
                        completeProfileForm.city.valid = false
                        completeProfileForm.city.msg = errors.city.message
                    }
                });
            },
            async complete() {
                // call local validation
                this.$v.completeProfileForm.$touch();
                this.submitted = true;
                if (this.$v.completeProfileForm.$pending || this.$v.completeProfileForm.$error || !this.selectedCategory) return;

                let completeProfileForm = this.completeProfileForm
                // send update request
                this.$axios.put(process.env.BACKEND_API + '/user/lawyer/profile', {
                    "name": completeProfileForm.name.val,
                    "profession": this.selectedCategory.name,
                    "description": completeProfileForm.description.val,
                    "city": completeProfileForm.city.val,
                }).then(results => {
                    completeProfileForm.name.valid = true
                    completeProfileForm.profession.valid = true
                    completeProfileForm.description.valid = true
                    completeProfileForm.city.valid = true
                    completeProfileForm.success = true;
                    completeProfileForm.sent = true;
                    completeProfileForm.loading = false
                    Vue.notify({
                        group: 'foo',
                        type: 'success',
                        title: 'Sign up',
                        text: 'Successfully completed profile!'
                    })
                    $('#modal-form').modal('hide')
                    this.$auth.fetchUser()
                }).catch(error => {
                    console.log(error);
                    completeProfileForm.loading = false;
                    completeProfileForm.success = false;
                    completeProfileForm.sent = true;
                    Vue.notify({
                        group: 'foo',
                        type: 'error',
                        title: 'Error',
                        text: typeof error.response.data == 'string' ? error.response.data : 'Something went wrong!'
                    })
                    let errors = error.response.data.errors
                    if ("name" in errors) {
                        completeProfileForm.name.valid = false
                        completeProfileForm.name.msg = errors.name.message
                    }
                    if ("profession" in errors) {
                        completeProfileForm.profession.valid = false
                        completeProfileForm.profession.msg = errors.profession.message
                    }
                    if ("description" in errors) {
                        completeProfileForm.description.valid = false
                        completeProfileForm.description.msg = errors.description.message
                    }
                    if ("city" in errors) {
                        completeProfileForm.city.valid = false
                        completeProfileForm.city.msg = errors.city.message
                    }
                });
            }
        }
    };
</script>
<style></style>
